Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1796)
+++ palm/trunk/SOURCE/Makefile	(revision 1797)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# dependcy for check_for_restart updated
 # 
 # Former revisions:
@@ -342,5 +342,5 @@
 calc_precipitation.o: modules.o mod_kinds.o
 calc_radiation.o: modules.o mod_kinds.o
-check_for_restart.o: modules.o mod_kinds.o
+check_for_restart.o: modules.o mod_kinds.o pmc_interface.o
 check_open.o: modules.o mod_kinds.o mod_particle_attributes.o netcdf_interface.o
 check_parameters.o: modules.o mod_kinds.o land_surface_model.o \
Index: palm/trunk/SOURCE/check_for_restart.f90
===================================================================
--- palm/trunk/SOURCE/check_for_restart.f90	(revision 1796)
+++ palm/trunk/SOURCE/check_for_restart.f90	(revision 1797)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! check now accounts for nesting mode
 ! 
 ! Former revisions:
@@ -70,13 +70,19 @@
                termination_time_needed, time_restart,                          &
                time_since_reference_point, write_binary
+
     USE kinds
+
     USE pegrid
 
+    USE pmc_interface,                                                         &
+        ONLY:  comm_world_nesting, cpl_id, nested_run
+
     IMPLICIT NONE
 
-
-    LOGICAL :: terminate_run_l           !<
-    LOGICAL :: do_stop_now = .FALSE.     !<
-    LOGICAL :: do_restart_now = .FALSE.  !<
+    INTEGER ::  global_communicator       !< global communicator to be used here
+
+    LOGICAL ::  terminate_run_l           !<
+    LOGICAL ::  do_stop_now = .FALSE.     !<
+    LOGICAL ::  do_restart_now = .FALSE.  !<
 
     REAL(wp) ::  remaining_time !<
@@ -96,11 +102,20 @@
     ENDIF
 
+!
+!-- Set the global communicator to be used (depends on the mode in which PALM is
+!-- running)
+    IF ( nested_run )  THEN
+       global_communicator = comm_world_nesting
+    ELSE
+       global_communicator = comm2d
+    ENDIF
+
 #if defined( __parallel )
 !
 !-- Make a logical OR for all processes. Stop the model run if at least
-!-- one processor has reached the time limit.
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL,        &
-                        MPI_LOR, comm2d, ierr )
+!-- one process has reached the time limit.
+    IF ( collective_wait )  CALL MPI_BARRIER( global_communicator, ierr )
+    CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL,     &
+                        MPI_LOR, global_communicator, ierr )
 #else
     terminate_run = terminate_run_l
@@ -164,9 +179,9 @@
 #if defined( __parallel )
 !
-!-- Make a logical OR for all processes. Stop the model run if at least
-!-- one processor has reached the time limit.
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+!-- Make a logical OR for all processes. Stop the model run if a flag file has
+!-- been detected above.
+    IF ( collective_wait )  CALL MPI_BARRIER( global_communicator, ierr )
     CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL,        &
-                        MPI_LOR, comm2d, ierr )
+                        MPI_LOR, global_communicator, ierr )
 #else
     terminate_run = terminate_run_l
@@ -256,5 +271,6 @@
 !-- the start of a continuation run, except if the user forced to stop the
 !-- run without restart
-    IF ( terminate_run  .AND.  myid == 0 .AND. .NOT. do_stop_now)  THEN
+    IF ( terminate_run  .AND.  myid == 0  .AND.  cpl_id == 1  .AND.            &
+         .NOT. do_stop_now)  THEN
 
        OPEN ( 90, FILE='CONTINUE_RUN', FORM='FORMATTED' )
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1796)
+++ palm/trunk/SOURCE/header.f90	(revision 1797)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! output of nesting datatransfer mode
 !
 ! Former revisions:
@@ -291,5 +291,5 @@
 
     USE pmc_interface,                                                         &
-        ONLY:  nested_run, nesting_mode
+        ONLY:  nested_run, nesting_datatransfer_mode, nesting_mode
 
     USE radiation_model_mod,                                                   &
@@ -483,5 +483,6 @@
     IF ( nested_run )  THEN
 
-       WRITE ( io, 600 )  TRIM( nesting_mode )
+       WRITE ( io, 600 )  TRIM( nesting_mode ),                                &
+                          TRIM( nesting_datatransfer_mode )
        CALL pmc_get_model_info( ncpl = ncpl, cpl_id = my_cpl_id )
 
@@ -2476,5 +2477,6 @@
 600 FORMAT (/' Nesting informations:'/ &
             ' --------------------'/ &
-            ' Nesting mode:                     ',A// &
+            ' Nesting mode:                     ',A/ &
+            ' Nesting-datatransfer mode:        ',A// &
             ' Nest id  parent  number   lower left coordinates   name'/ &
             ' (*=me)     id    of PEs      x (m)     y (m)' )
Index: palm/trunk/SOURCE/pmc_client.f90
===================================================================
--- palm/trunk/SOURCE/pmc_client.f90	(revision 1796)
+++ palm/trunk/SOURCE/pmc_client.f90	(revision 1797)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-!
+! introduction of different datatransfer modes
 !
 ! Former revisions:
@@ -401,5 +401,5 @@
        do i=1,me%inter_npes
           aPE => me%PEs(i)
-          ar  => aPE%array_list(next_array_in_list)    !actual array is last array in list
+          ar  => aPE%array_list(next_array_in_list)
           ar%NrDims    = NrDims
           ar%A_dim     = dims
@@ -575,8 +575,15 @@
       INTEGER(kind=MPI_ADDRESS_KIND)    ::  target_disp
 
-      t1 = PMC_Time()
-      CALL MPI_Barrier(me%intra_comm, ierr)                         ! Wait for server to fill buffer
-      t2 = PMC_Time()-t1
-      if(present(WaitTime)) WaitTime = t2
+!
+!--   Synchronization of the model is done in pmci_client_synchronize and pmci_server_synchronize
+!--   Therefor the RMA window can be filled without sychronization at this point and a barrier
+!--   is not necessary
+!--   Please note that WaitTime has to be set in PMC_S_FillBuffer AND PMC_C_GetBuffer
+      if(present(WaitTime))  then
+         t1 = PMC_Time()
+         CALL MPI_Barrier(me%intra_comm, ierr)
+         t2 = PMC_Time()
+         WaitTime = t2-t1
+      end if
 
       CALL MPI_Barrier(me%intra_comm, ierr)                         ! Wait for buffer is filled
Index: palm/trunk/SOURCE/pmc_handle_communicator.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1796)
+++ palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1797)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! introduction of different datatransfer modes,
+! export of comm_world_nesting
 !
 ! Former revisions:
@@ -90,4 +91,5 @@
    ! Coupler Setup
 
+   INTEGER                                    :: m_world_comm !global nesting communicator
    INTEGER                                    :: m_my_CPL_id  !Coupler id of this model
    INTEGER                                    :: m_Parent_id  !Coupler id of parent of this model
@@ -125,5 +127,6 @@
  CONTAINS
 
-   SUBROUTINE pmc_init_model( comm, nesting_mode, pmc_status )
+   SUBROUTINE pmc_init_model( comm, nesting_datatransfer_mode, nesting_mode,   &
+                              pmc_status )
 
       USE control_parameters,                                                  &
@@ -136,4 +139,5 @@
 
       CHARACTER(LEN=7), INTENT(OUT) ::  nesting_mode
+      CHARACTER(LEN=7), INTENT(OUT) ::  nesting_datatransfer_mode
 
       INTEGER, INTENT(OUT)                ::  comm
@@ -148,4 +152,5 @@
       pmc_status   = pmc_status_ok
       comm         = -1
+      m_world_comm = MPI_COMM_WORLD
       m_my_cpl_id  = -1
       clientcount  =  0
@@ -159,5 +164,6 @@
       IF ( m_world_rank == 0 )  THEN
 
-         CALL read_coupling_layout( nesting_mode, pmc_status )
+         CALL read_coupling_layout( nesting_datatransfer_mode, nesting_mode,   &
+                                    pmc_status )
 
          IF ( pmc_status /= pmc_no_namelist_found  .AND.                       &
@@ -221,5 +227,7 @@
          CALL MPI_BCAST( m_couplers(i)%lower_left_x, 1, MPI_REAL,    0, MPI_COMM_WORLD, istat )
          CALL MPI_BCAST( m_couplers(i)%lower_left_y, 1, MPI_REAL,    0, MPI_COMM_WORLD, istat )
+!--      TO_DO: the next two calls can and should probably moved outside this loop
          CALL MPI_BCAST( nesting_mode, LEN( nesting_mode ), MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( nesting_datatransfer_mode, LEN(nesting_datatransfer_mode), MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
       ENDDO
 
@@ -329,7 +337,7 @@
 !
 !-- Provide module private variables of the pmc for PALM
-    SUBROUTINE pmc_get_model_info( cpl_id, cpl_name, cpl_parent_id,            &
-                                   lower_left_x, lower_left_y, ncpl, npe_total,&
-                                   request_for_cpl_id )
+    SUBROUTINE pmc_get_model_info( comm_world_nesting, cpl_id, cpl_name,       &
+                                   cpl_parent_id, lower_left_x, lower_left_y,  &
+                                   ncpl, npe_total, request_for_cpl_id )
 
       USE kinds
@@ -341,4 +349,5 @@
       INTEGER, INTENT(IN), OPTIONAL ::  request_for_cpl_id
 
+      INTEGER, INTENT(OUT), OPTIONAL ::  comm_world_nesting
       INTEGER, INTENT(OUT), OPTIONAL ::  cpl_id
       INTEGER, INTENT(OUT), OPTIONAL ::  cpl_parent_id
@@ -364,6 +373,9 @@
 !
 !--   Return the requested information
+      IF ( PRESENT( comm_world_nesting )  )  THEN
+         comm_world_nesting = m_world_comm
+      ENDIF
       IF ( PRESENT( cpl_id )        )  THEN
-         cpl_id        = requested_cpl_id
+         cpl_id = requested_cpl_id
       ENDIF
       IF ( PRESENT( cpl_parent_id ) )  THEN
@@ -371,17 +383,17 @@
       ENDIF
       IF ( PRESENT( cpl_name )      )  THEN
-         cpl_name      = m_couplers(requested_cpl_id)%name
+         cpl_name = m_couplers(requested_cpl_id)%name
       ENDIF
       IF ( PRESENT( ncpl )          )  THEN
-         ncpl          = m_ncpl
+         ncpl = m_ncpl
       ENDIF
       IF ( PRESENT( npe_total )     )  THEN
-         npe_total     = m_couplers(requested_cpl_id)%npe_total
+         npe_total = m_couplers(requested_cpl_id)%npe_total
       ENDIF
       IF ( PRESENT( lower_left_x )  )  THEN
-         lower_left_x  = m_couplers(requested_cpl_id)%lower_left_x
+         lower_left_x = m_couplers(requested_cpl_id)%lower_left_x
       ENDIF
       IF ( PRESENT( lower_left_y )  )  THEN
-         lower_left_y  = m_couplers(requested_cpl_id)%lower_left_y
+         lower_left_y = m_couplers(requested_cpl_id)%lower_left_y
       ENDIF
 
@@ -400,9 +412,11 @@
 
 
- SUBROUTINE read_coupling_layout( nesting_mode, pmc_status )
+ SUBROUTINE read_coupling_layout( nesting_datatransfer_mode, nesting_mode,     &
+                                  pmc_status )
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=7) ::  nesting_mode
+    CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_mode
+    CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_datatransfer_mode
 
     INTEGER, INTENT(INOUT) ::  pmc_status
@@ -412,5 +426,5 @@
 
 
-    NAMELIST /nestpar/  domain_layouts, nesting_mode
+    NAMELIST /nestpar/  domain_layouts, nesting_datatransfer_mode, nesting_mode
 
 !
Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1796)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1797)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-!
+! introduction of different datatransfer modes,
+! further formatting cleanup, parameter checks added (including mismatches
+! between root and client model settings),
+! +routine pmci_check_setting_mismatches
+! comm_world_nesting introduced
 !
 ! Former revisions:
@@ -145,4 +149,5 @@
 !
 !-- Coupler setup
+    INTEGER(iwp), SAVE      ::  comm_world_nesting     !:
     INTEGER(iwp), SAVE      ::  cpl_id  = 1            !:
     CHARACTER(LEN=32), SAVE ::  cpl_name               !:
@@ -152,4 +157,7 @@
 !
 !-- Control parameters, will be made input parameters later
+    CHARACTER(LEN=7), SAVE ::  nesting_datatransfer_mode = 'mixed'  !: steering
+                                                         !: parameter for data-
+                                                         !: transfer mode
     CHARACTER(LEN=7), SAVE ::  nesting_mode = 'two-way'  !: steering parameter
                                                          !: for 1- or 2-way nesting
@@ -308,6 +316,6 @@
 
 
-    INTERFACE pmci_client_datatrans
-       MODULE PROCEDURE pmci_client_datatrans
+    INTERFACE pmci_check_setting_mismatches
+       MODULE PROCEDURE pmci_check_setting_mismatches
     END INTERFACE
 
@@ -320,4 +328,8 @@
     END INTERFACE
 
+    INTERFACE pmci_datatrans
+       MODULE PROCEDURE pmci_datatrans
+    END INTERFACE pmci_datatrans
+
     INTERFACE pmci_ensure_nest_mass_conservation
        MODULE PROCEDURE pmci_ensure_nest_mass_conservation
@@ -346,13 +358,13 @@
     PUBLIC anterp_relax_length_l, anterp_relax_length_r,                       &
            anterp_relax_length_s, anterp_relax_length_n,                       &
-           anterp_relax_length_t, client_to_server, cpl_id, nested_run,        &
-           nesting_mode, server_to_client
-    PUBLIC pmci_client_datatrans
+           anterp_relax_length_t, client_to_server, comm_world_nesting,        &
+           cpl_id, nested_run, nesting_datatransfer_mode, nesting_mode,        &
+           server_to_client
     PUBLIC pmci_client_initialize
     PUBLIC pmci_client_synchronize
+    PUBLIC pmci_datatrans
     PUBLIC pmci_ensure_nest_mass_conservation
     PUBLIC pmci_init
     PUBLIC pmci_modelconfiguration
-    PUBLIC pmci_server_datatrans
     PUBLIC pmci_server_initialize
     PUBLIC pmci_server_synchronize
@@ -365,4 +377,7 @@
  SUBROUTINE pmci_init( world_comm )
 
+    USE control_parameters,                                                  &
+        ONLY:  message_string
+
     IMPLICIT NONE
 
@@ -376,5 +391,6 @@
 
 
-    CALL pmc_init_model( world_comm, nesting_mode, pmc_status )
+    CALL pmc_init_model( world_comm, nesting_datatransfer_mode, nesting_mode,  &
+                         pmc_status )
 
     IF ( pmc_status == pmc_no_namelist_found )  THEN
@@ -390,4 +406,22 @@
 
 !
+!-- Check steering parameter values
+    IF ( TRIM( nesting_mode ) /= 'one-way'  .AND.                              &
+         TRIM( nesting_mode ) /= 'two-way' )                                   &
+    THEN
+       message_string = 'illegal nesting mode: ' // TRIM( nesting_mode )
+       CALL message( 'pmci_init', 'PA0417', 3, 2, 0, 6, 0 )
+    ENDIF
+
+    IF ( TRIM( nesting_datatransfer_mode ) /= 'cascade'  .AND.                 &
+         TRIM( nesting_datatransfer_mode ) /= 'mixed'    .AND.                 &
+         TRIM( nesting_datatransfer_mode ) /= 'overlap' )                      &
+    THEN
+       message_string = 'illegal nesting datatransfer mode: '                  &
+                        // TRIM( nesting_datatransfer_mode )
+       CALL message( 'pmci_init', 'PA0418', 3, 2, 0, 6, 0 )
+    ENDIF
+
+!
 !-- Set the general steering switch which tells PALM that its a nested run
     nested_run = .TRUE.
@@ -396,5 +430,6 @@
 !-- Get some variables required by the pmc-interface (and in some cases in the
 !-- PALM code out of the pmci) out of the pmc-core
-    CALL pmc_get_model_info( cpl_id = cpl_id, cpl_parent_id = cpl_parent_id,   &
+    CALL pmc_get_model_info( comm_world_nesting = comm_world_nesting,          &
+                             cpl_id = cpl_id, cpl_parent_id = cpl_parent_id,   &
                              cpl_name = cpl_name, npe_total = cpl_npe_total,   &
                              lower_left_x = lower_left_coord_x,                &
@@ -445,4 +480,8 @@
 !-- Initialize PMC Server
     CALL pmci_setup_server
+!
+!-- Check for mismatches between settings of master and client variables
+!-- (e.g., all clients have to follow the end_time settings of the root master)
+    CALL pmci_check_setting_mismatches
 
     CALL location_message( 'finished', .TRUE. )
@@ -701,5 +740,5 @@
        ELSE
 !
-!--       TO_DO: Klaus: comment why thie dummy allocation is required
+!--       TO_DO: Klaus: comment why this dummy allocation is required
           ALLOCATE( index_list(6,1) )
           CALL pmc_s_set_2d_index_list( client_id, index_list )
@@ -789,8 +828,4 @@
                                      SIZE(define_coarse_grid_real), 0, 21, ierr )
           CALL pmc_recv_from_server( define_coarse_grid_int,  3, 0, 22, ierr )
-
-!
-!--       Receive also the dz-,zu- and zw-arrays here.
-!--       TO_DO: what is the meaning of above comment
 !
 !--        Debug-printouts - keep them
@@ -852,6 +887,8 @@
        
 !
-!--    TO_DO: give comments what is happening here
+!--    Find the index bounds for the nest domain in the coarse-grid index space
        CALL pmci_map_fine_to_coarse_grid
+!
+!--    TO_DO: Klaus give a comment what is happening here
        CALL pmc_c_get_2d_index_list
 
@@ -879,6 +916,7 @@
 
 !
-!--    Two-way coupling
-!--    TO_DO: comment what is happening here
+!--    Two-way coupling.
+!--    Precompute the index arrays and relaxation functions for the
+!--    anterpolation
        IF ( nesting_mode == 'two-way' )  THEN
           CALL pmci_init_anterp_tophat
@@ -895,5 +933,7 @@
 
     SUBROUTINE pmci_map_fine_to_coarse_grid
-
+!
+!--    Determine index bounds of interpolation/anterpolation area in the coarse
+!--    grid index space
        IMPLICIT NONE
 
@@ -907,6 +947,5 @@
 
 !
-!--    Determine indices of interpolation/anterpolation area in the coarse grid
-!--    If the fine- and coarse grid nodes do not match.
+!--    If the fine- and coarse grid nodes do not match:
        loffset = MOD( coord_x(nxl), cg%dx )
        xexl    = cg%dx + loffset
@@ -991,5 +1030,5 @@
 !--    Precomputation of the interpolation coefficients and client-array indices
 !--    to be used by the interpolation routines interp_tril_lr, interp_tril_ns
-!--    and interp_tril_t. Constant dz is still assumed.
+!--    and interp_tril_t.
 
        IMPLICIT NONE
@@ -1199,4 +1238,5 @@
 !--    Left boundary
        IF ( nest_bound_l )  THEN
+
           ALLOCATE( logc_u_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2) )
           ALLOCATE( logc_v_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2) )
@@ -1235,4 +1275,5 @@
 
           ENDDO
+
        ENDIF
 
@@ -1240,4 +1281,5 @@
 !--    Right boundary
        IF ( nest_bound_r )  THEN
+
           ALLOCATE( logc_u_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
           ALLOCATE( logc_v_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
@@ -1252,5 +1294,5 @@
           DO  j = nys, nyn
 !
-!--          Right boundary for u.
+!--          Right boundary for u
              i   = nxr + 1
              kb  = nzb_u_inner(j,i)
@@ -1262,7 +1304,6 @@
              logc_ratio_u_r(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
              lcr(0:ncorr-1) = 1.0_wp
-
-!
-!--          Right boundary for v.
+!
+!--          Right boundary for v
              i   = nxr + 1
              kb  = nzb_v_inner(j,i)
@@ -1276,4 +1317,5 @@
 
           ENDDO
+
        ENDIF
 
@@ -1281,4 +1323,5 @@
 !--    South boundary
        IF ( nest_bound_s )  THEN
+
           ALLOCATE( logc_u_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2) )
           ALLOCATE( logc_v_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2) )
@@ -1291,7 +1334,8 @@
           direction      = 1
           inc            = 1
+
           DO  i = nxl, nxr
 !
-!--          South boundary for u.
+!--          South boundary for u
              j   = -1
              kb  =  nzb_u_inner(j,i)
@@ -1303,5 +1347,4 @@
              logc_ratio_u_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
              lcr(0:ncorr-1) = 1.0_wp
-
 !
 !--          South boundary for v
@@ -1315,5 +1358,7 @@
              logc_ratio_v_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
              lcr(0:ncorr-1) = 1.0_wp
-          ENDDO
+
+          ENDDO
+
        ENDIF
 
@@ -1321,4 +1366,5 @@
 !--    North boundary
        IF ( nest_bound_n )  THEN
+
           ALLOCATE( logc_u_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2) )
           ALLOCATE( logc_v_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2) )
@@ -1331,7 +1377,8 @@
           direction      = 1
           inc            = 1
+
           DO  i = nxl, nxr
 !
-!--          North boundary for u.
+!--          North boundary for u
              j   = nyn + 1
              kb  = nzb_u_inner(j,i)
@@ -1343,7 +1390,6 @@
              logc_ratio_u_n(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
              lcr(0:ncorr-1) = 1.0_wp
-
-!
-!--          North boundary for v.
+!
+!--          North boundary for v
              j   = nyn + 1
              kb  = nzb_v_inner(j,i)
@@ -1357,13 +1403,16 @@
 
           ENDDO
+
        ENDIF
 
 !       
-!--    Then vertical walls and corners if necessary.
+!--    Then vertical walls and corners if necessary
        IF ( topography /= 'flat' )  THEN
+
           kb = 0       ! kb is not used when direction > 1
 !        
 !--       Left boundary
           IF ( nest_bound_l )  THEN
+
              ALLOCATE( logc_w_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2) )
              ALLOCATE( logc_ratio_w_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2,       &
@@ -1374,5 +1423,4 @@
              DO  j = nys, nyn
                 DO  k = nzb, nzt_topo_nestbc_l
-
 !
 !--                Wall for u on the south side, but not on the north side
